Bug 2137 - [vm] systat(1) total vm statistics are bad
Summary: [vm] systat(1) total vm statistics are bad
Status: Closed FIXED
Alias: None
Product: Base System
Classification: Unclassified
Component: bin (show other bugs)
Version: 3.0-CURRENT
Hardware: Any Any
: Normal Affects Many People
Assignee: Konstantin Belousov
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 1996-12-02 22:00 UTC by Tor Egge
Modified: 2018-02-02 20:13 UTC (History)
5 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Tor Egge 1996-12-02 22:00:02 UTC
	Running systat shows bad values for total virtual memory. e.g.
        In this example, it shows 3274676 KB, while it should be 
	                      77316980216 KB.

---- systat output
    3 users    Load  0.18  0.38  0.20                  Mon Dec  2 18:35

Mem:KB    REAL            VIRTUAL                     VN PAGER  SWAP PAGER
        Tot   Share      Tot    Share    Free         in  out     in  out
Act   25168    3984  4143252     4492  329352 count
All  193988    4820  3274676     6664         pages
--- top output
 last pid:   530;  load averages:  0.14,  0.34,  0.20                   18:36:00
50 processes:  2 running, 48 sleeping
CPU states:  1.2% user,  0.0% nice,  1.2% system,  0.0% interrupt, 97.7% idle
Mem: 151M Active, 8728K Inact, 22M Wired, 8345K Buf, 322M Free
Swap: 685M Total, 64K Used, 685M Free
---- vmtotal structure contents
$1 = {t_rq = 2, t_dw = 0, t_pw = 0, t_sl = 21, t_sw = 0, t_vm = -2145615227, 
  t_avm = 1036180, t_rm = 48722, t_arm = 6262, t_vmshr = 1681, 
  t_avmshr = 1516, t_rmshr = 1217, t_armshr = 1109, t_free = 82113}
----

Using 64 bit numbers, counting the same vm objects, the result is 19329245054,
which means 73735 GB total virtual memory.

Fix: 

Use 64 bits arithmetic in showkre() in /usr/src/usr.bin/systat/vmstat.c.
Make space for a 12 digit number showing the total virtual memory.

optional extra change in vmtotal() in /usr/src/sys/vm/vm_meter.c:
	
  By ignoring the objects where object->size == 0x7fffffff, the t_vm field
  in the vmtotal structure will have a low lower value. These objects are of
  type OBJT_VNODE, referencing vnodes of type VBLK and tag VT_UFS, referencing
  inodes for the block devices corresponding to the currently mounted ufs file
  systems. Not ignoring them means adding almost 8192 GB virtual memory for
  each mounted ufs filesystem.

  By ignoring the objects where object->ref_count == 0, you will also 
  reduce the t_vm field somewhat.
How-To-Repeat: 
   run systat.
Comment 1 Poul-Henning Kamp freebsd_committer 1998-05-25 09:04:10 UTC
State Changed
From-To: open->suspended

Awaiting committer 
Comment 2 Jesper Skriver freebsd_committer 2001-05-28 00:09:06 UTC
Responsible Changed
From-To: freebsd-bugs->tegge

Originator is now a commit'er himself
Comment 3 Mark Linimon freebsd_committer freebsd_triage 2008-04-25 11:05:48 UTC
Responsible Changed
From-To: tegge->freebsd-bugs

tegge has returned his commit bit for safekeeping.
Comment 4 Enji Cooper freebsd_committer 2015-11-10 09:01:50 UTC
This is still sadly valid on 11-CURRENT -- please note that the amount of memory shown is negative ~2GB :(...

This affects many people because... having this much memory is commonplace now.

% sysctl hw.physmem
hw.physmem: 3188523008
% systat -vmstat

    6 users    Load  0.38  0.28  0.82                  Nov 10 00:59

Mem:KB    REAL            VIRTUAL                       VN PAGER   SWAP PAGER
        Tot   Share      Tot    Share    Free           in   out     in   out
Act   24340    7768   577584    11968  114780  count
All   27000    7816   -2146M    24652          pages
Comment 5 Pawel Biernacki freebsd_committer 2017-11-15 13:53:36 UTC
Partial fix was committed in r325852 https://lists.freebsd.org/pipermail/svn-src-head/2017-November/106221.html.

I've separate patches for systat and vmstat that are needed to take advantage of the new struct vmtotal size.  Stay tuned.
Comment 6 commit-hook freebsd_committer 2017-11-21 19:55:58 UTC
A commit references this bug:

Author: kib
Date: Tue Nov 21 19:55:32 UTC 2017
New revision: 326073
URL: https://svnweb.freebsd.org/changeset/base/326073

Log:
  systat: use and correctly display 64bit counters.

  Following struct vmtotal changes, make systat use and correctly
  display 64-bit counters.  Switch to humanize_number(3) to overcome
  homegrown arithmetics limits in pretty printing large numbers.  Use
  1024 as a divisor for memory fields to make it consistent with other
  tools and users expectations.

  Submitted by:	Pawel Biernacki <pawel.biernacki@gmail.com>
  Sponsored by:	Mysterious Code Ltd.
  PR:	2137
  Differential revision:	https://reviews.freebsd.org/D13105

Changes:
  head/usr.bin/systat/Makefile
  head/usr.bin/systat/vmstat.c
Comment 7 Pawel Biernacki freebsd_committer 2017-11-23 19:22:35 UTC
Final change has been committed in r326139.  All base system consumers of struct vmtotal are now properly displaying large counters.
Comment 8 Eugene Grosbein freebsd_committer 2018-02-02 20:13:44 UTC
Fixed over two months ago. No MFC planned.